org.apache.tapestry5

## Class SymbolConstants

- java.lang.Object
- - org.apache.tapestry5.SymbolConstants

-     public class SymbolConstants
      extends Object

  Defines the names of symbols used to configure Tapestry.
  See Also:
    `SymbolSource`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `AJAX_FORM_LOOP_ADD_ROW_LINK_CSS_CLASS` Defines the CSS class that will be given to the add row link generated by AjaxFormLoop.
    `static String` | `APPLICATION_CATALOG` The location of the application-wide component messages catalog, relative to the web application context.
    `static String` | `APPLICATION_FOLDER` The name of a folder in which the Tapestry application executes.
    `static String` | `APPLICATION_VERSION` Version number of the application.
    `static String` | `ASSET_PATH_PREFIX` Prefix to be used for all resource paths, used to recognize which requests are for assets.
    `static String` | `ASSET_URL_FULL_QUALIFIED` Boolean value to indicate if every `Asset2` should be fully qualified or not.
    `static String` | `BEAN_DISPLAY_CSS_CLASS` Defines the CSS class that will be given to the <dl> HTML element generated by BeanDisplay.
    `static String` | `BEAN_EDITOR_BOOLEAN_PROPERTY_DIV_CSS_CLASS` Defines the CSS class that will be given to the <div> HTML element generated by BeanEditor/BeanEditForm for boolean properties.
    `static String` | `BOOTSTRAP_ROOT` The root asset path for Twitter Bootstrap; if your application uses a modified version of Bootstrap, you can override this symbol to have Tapestry automatically use your version.
    `static String` | `CHARSET` The charset used when rendering page markup; the charset is also used as the request encoding when handling incoming requests.
    `static String` | `CLUSTERED_SESSIONS` If "true" then at the end of each request the `SessionPersistedObjectAnalyzer` will be called on each session persisted object that was accessed during the request.
    `static String` | `COMBINE_SCRIPTS` If "true" then JavaScript files in a `JavaScriptStack` will be combined into a single virtual JavaScript file.
    `static String` | `COMPACT_JSON` If "true", then JSON page initialization content is compressed; if "false" then extra white space is added (pretty printing).
    `static String` | `COMPONENT_RENDER_TRACING_ENABLED` If "true" and `PRODUCTION_MODE` is off, comments will be rendered before and after the rendering of any component allowing more visibility into which components rendered which markup.
    `static String` | `COMPRESS_WHITESPACE` Controls whether whitespace is compressed by default in templates, or left as is.
    `static String` | `CONTEXT_PATH` Identifies the context path of the application, as determined from `ServletContext.getContextPath()`.
    `static String` | `COOKIE_MAX_AGE` The default time interval that cookies created by Tapestry will be kept in the client web browser.
    `static String` | `DATEPICKER` The Asset path to the embedded datepicker.
    `static String` | `DEFAULT_STYLESHEET` The default stylesheet automatically inserted into every rendered HTML page when no Bootstrap version is enabled (i.e both `Trait.BOOTSTRAP_3` and `Trait.BOOTSTRAP_4` traits are disabled, something done by NoBootstrapModule).
    `static String` | `ENABLE_HTML5_SUPPORT` Defines whether HTML5 features should be used.
    `static String` | `ENABLE_PAGELOADING_MASK` If true, then when a page includes any JavaScript, a `script` block is added to insert a pageloader mask into the page; the pageloader mask ensure that the user can't interact with the page until after the page is fully initialized.
    `static String` | `ENCODE_LOCALE_INTO_PATH` If "true" (the default), then the `PersistentLocale` will be encoded into the `Link` path by the `ComponentEventLinkEncoder` service.
    `static String` | `ERROR_CSS_CLASS` Defines the CSS class that will be given to the HTML element generated by Error.
    `static String` | `ERRORS_BASE_CSS_CLASS` Defines the prefix of the CSS class that will be given to the outer <div> element generated by Errors.
    `static String` | `ERRORS_CLOSE_BUTTON_CSS_CLASS` Defines the CSS class that will be given to the close <button> generated by Errors.
    `static String` | `ERRORS_DEFAULT_CLASS_PARAMETER_VALUE` Defines the default value of the Errors's `class` parameter.
    `static String` | `EXCEPTION_REPORT_PAGE` Name of page used to report exceptions; the page must implement `ExceptionReporter`.
    `static String` | `EXCEPTION_REPORTS_DIR` The directory to which exception report files should be written.
    `static String` | `EXECUTION_MODE` A comma separated list of execution modes used to control how the application is initialized.
    `static String` | `FILE_CHECK_INTERVAL` Time interval defining how often Tapestry will check for updates to local files (including classes).
    `static String` | `FILE_CHECK_UPDATE_TIMEOUT` Time interval that sets how long Tapestry will wait to obtain the exclusive lock needed to check local files.
    `static String` | `FONT_AWESOME_ROOT` The root asset path for Font Awesome; if your application uses a modified version of it, you can override this symbol to have Tapestry automatically use your version.
    `static String` | `FORM_CLIENT_LOGIC_ENABLED` Used as the default for the Form's autofocus and clientValidation parameters.
    `static String` | `FORM_FIELD_CSS_CLASS` Defines the CSS class that will be given to form field components which are AbstractField subclasses.
    `static String` | `FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS` Defines the CSS class of the HTML element generated by the FormGroup mixin and the BeanEditForm and BeanEditor.
    `static String` | `FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME` Defines the name of the HTML element that will surround the HTML form field generated by the FormGroup mixin and the BeanEditForm and BeanEditor.
    `static String` | `FORM_GROUP_LABEL_CSS_CLASS` Defines the CSS class that will be given to <label> element generated by the FormGroup mixin and the BeanEditForm and BeanEditor components.
    `static String` | `FORM_GROUP_WRAPPER_CSS_CLASS` Defines the CSS class that will be given to HTML element (usually a div) <div> generated by the FormGroup mixin and the BeanEditForm and BeanEditor components surrounding the label and the field.
    `static String` | `GZIP_COMPRESSION_ENABLED` If "true" (the default) then GZip compression is enabled for dynamic requests and for static assets.
    `static String` | `HMAC_PASSPHRASE` A passphrase used as the basis of hash-based message authentication (HMAC) for any object stream data stored on the client.
    `static String` | `HOSTNAME` The hostname that application should use when constructing an absolute URL.
    `static String` | `HOSTPORT` The hostport that application should use when constructing an absolute URL.
    `static String` | `HOSTPORT_SECURE` The secure (https) hostport that application should use when constructing an absolute URL.
    `static String` | `INCLUDE_CORE_STACK` If true (the default), then Tapestry will automatically include the "core" stack in all pages.
    `static String` | `JAVASCRIPT_INFRASTRUCTURE_PROVIDER` Tapestry relies on an underlying client-side JavaScript infrastructure framework to handle DOM manipulation, event handling, and Ajax requests.
    `static String` | `LENIENT_DATE_FORMAT` Defines whether `DateFormat` instances created by Tapestry should be lenient or not by default.
    `static String` | `MIN_GZIP_SIZE` Minimum output stream size, in bytes, before output is compressed using GZIP.
    `static String` | `MINIFICATION_ENABLED` If "true", then resources (individually or when aggregated into stacks) will be minimized via the `ResourceMinimizer` service.
    `static String` | `MODULE_PATH_PREFIX` Prefix used for all module resources.
    `static String` | `OMIT_EXPIRATION_CACHE_CONTROL_HEADER` When an asset (typically, a JavaScript module) is streamed without an explicit expiration header, then this value is sent as the `Cache-Control` header; the default is "max-age=60, must-revalidate".
    `static String` | `OMIT_GENERATOR_META` Used to omit the normal Tapestry framework generator meta tag.
    `static String` | `PERSISTENCE_STRATEGY` Identifies the default persistence strategy for all pages that do not provide an override (using this value as `key`).
    `static String` | `PRELOADER_MODE` Controls in what environment page preloading should occur.
    `static String` | `PRODUCTION_MODE` Indicates whether Tapestry is running in production mode or developer mode.
    `static String` | `PRODUCTION_MODE_VALUE` A version of `PRODUCTION_MODE` as a symbol reference.
    `static String` | `RESTRICTIVE_ENVIRONMENT` A general switch for restrictive environments, such as Google App Engine, which forbid some useful operations, such as creating files or directories.
    `static String` | `SCRIPTACULOUS` The Asset path to the embedded copy of script.aculo.us packaged with Tapestry.
    `static String` | `SECURE_ENABLED` If "true" (which itself defaults to production mode), then the `Secure` annotation will be honored.
    `static String` | `SESSION_LOCKING_ENABLED` If true (the default), then Tapestry will apply locking semantics around access to the `HttpSession`.
    `static String` | `START_PAGE_NAME` The logical name of the start page, the page that is rendered for the root URL.
    `static String` | `STRICT_CSS_URL_REWRITING` Defines whether `CSSURLRewriter` will throw an exception when a CSS file references an URL which doesn't exist.
    `static String` | `SUPPORTED_LOCALES` The list of locales supported by the application; locales identified in the incoming request are "narrowed" to one of these values.
    `static String` | `TAPESTRY_VERSION` The version number of the core Tapestry framework, or UNKNOWN if the version number is not available (which should only occur when developing Tapestry).

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SymbolConstants()`

  - ### Method Summary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### EXECUTION_MODE

          public static final String EXECUTION_MODE

      A comma separated list of execution modes used to control how the application is initialized. Each modes can contribute a list (comma separated) of Module classes to be loaded during startup, the order in which they appear is preserved. The default value is: `production`.
      See Also:
        Constant Field Values

    - #### PRODUCTION_MODE

          public static final String PRODUCTION_MODE

      Indicates whether Tapestry is running in production mode or developer mode. This affects a large number of Tapestry behaviors related to performance and security, including how exceptions are reported, whether far-future expire headers are emitted, whether JavaScript files may be combined, whether JSON is compressed, whether component field and parameter values are shadowed to instance variables (to assist with debugging), and more.
      See Also:
        Constant Field Values

    - #### PRODUCTION_MODE_VALUE

          public static final String PRODUCTION_MODE_VALUE

      A version of `PRODUCTION_MODE` as a symbol reference. This can be used as the default value of other symbols, to indicate that their default matches whatever PRODUCTION_MODE is set to, which is quite common.
      Since:
        5.2.0

    - #### SUPPORTED_LOCALES

          public static final String SUPPORTED_LOCALES

      The list of locales supported by the application; locales identified in the incoming request are "narrowed" to one of these values. The first locale name in the list is the default locale used when no proper match can be found.
      See Also:
        Constant Field Values

    - #### COMPRESS_WHITESPACE

          public static final String COMPRESS_WHITESPACE

      Controls whether whitespace is compressed by default in templates, or left as is. The factory default is to compress whitespace. (This can also be overridden using the xml:space attribute inside template elements.)
      See Also:
        Constant Field Values

    - #### FILE_CHECK_INTERVAL

          public static final String FILE_CHECK_INTERVAL

      Time interval defining how often Tapestry will check for updates to local files (including classes). Starting with 5.3, this is only used when not running in production mode. The default is "1 s" (one second), which is appropriate for development. With Tapestry 5.2 and earlier this number should be raised in a production environment.
      See Also:
        Constant Field Values

    - #### FILE_CHECK_UPDATE_TIMEOUT

          public static final String FILE_CHECK_UPDATE_TIMEOUT

      Time interval that sets how long Tapestry will wait to obtain the exclusive lock needed to check local files. The default is "50 ms". Starting with 5.3, this is only used when not running in production mode.
      See Also:
        Constant Field Values

    - #### TAPESTRY_VERSION

          public static final String TAPESTRY_VERSION

      The version number of the core Tapestry framework, or UNKNOWN if the version number is not available (which should only occur when developing Tapestry).
      See Also:
        Constant Field Values

    - #### APPLICATION_CATALOG

          public static final String APPLICATION_CATALOG

      The location of the application-wide component messages catalog, relative to the web application context. This will normally be `WEB-INF/app.properties`.
      See Also:
        Constant Field Values

    - #### CHARSET

          public static final String CHARSET

      The charset used when rendering page markup; the charset is also used as the request encoding when handling incoming requests. The default is "UTF-8".
      See Also:
        Constant Field Values

    - #### FORM_CLIENT_LOGIC_ENABLED

          public static final String FORM_CLIENT_LOGIC_ENABLED

      Used as the default for the Form's autofocus and clientValidation parameters. If overridden to "false", then Forms will not (unless explicitly specified) use client validation or autofocus, which in turn, means that most pages with Forms will not make use of the Tapestry JavaScript stack.
      See Also:
        Constant Field Values

    - #### EXCEPTION_REPORT_PAGE

          public static final String EXCEPTION_REPORT_PAGE

      Name of page used to report exceptions; the page must implement `ExceptionReporter`. This is used by the default exception report handler service.
      See Also:
        Constant Field Values

    - #### PERSISTENCE_STRATEGY

          public static final String PERSISTENCE_STRATEGY

      Identifies the default persistence strategy for all pages that do not provide an override (using this value as `key`).
      Since:
        5.1.0.0
      See Also:
        Constant Field Values

    - #### MIN_GZIP_SIZE

          public static final String MIN_GZIP_SIZE

      Minimum output stream size, in bytes, before output is compressed using GZIP. Shorter streams are not compressed. Tapestry buffers this amount and switches to a GZIP output stream as needed. The default is "100".
      Since:
        5.1.0.0
      See Also:
        `GZIP_COMPRESSION_ENABLED`, Constant Field Values

    - #### APPLICATION_VERSION

          public static final String APPLICATION_VERSION

      Version number of the application. Prior to 5.4, this version number was integrated into asset URLs. Starting with 5.4, a checksum of the individual asset's content is used instead, and this version number is only used for documentation purposes; it appears in the default exception report page, for example. The default value is "0.0.1". In 5.3 and earlier, the default value was a random hexadecimal string.
      Since:
        5.1.0.0
      See Also:
        `AssetDispatcher`, `AssetPathConstructor`, Constant Field Values

    - #### OMIT_GENERATOR_META

          public static final String OMIT_GENERATOR_META

      Used to omit the normal Tapestry framework generator meta tag. The meta tag is rendered by default, but clients who do not wish to advertise their use of Tapestry may set this symbol to "true".
      Since:
        5.1.0.0
      See Also:
        Constant Field Values

    - #### GZIP_COMPRESSION_ENABLED

          public static final String GZIP_COMPRESSION_ENABLED

      If "true" (the default) then GZip compression is enabled for dynamic requests and for static assets. If you are using a server that handles GZip compression for you, or you don't want to use the extra processing power necessary to GZIP requests, then override this to "false".
      Since:
        5.1.0.0
      See Also:
        `MIN_GZIP_SIZE`, `ResponseCompressionAnalyzer`, `CompressionAnalyzer`, Constant Field Values

    - #### SECURE_ENABLED

          public static final String SECURE_ENABLED

      If "true" (which itself defaults to production mode), then the `Secure` annotation will be honored. If "false" (i.e., development mode), then the annotation and related HTTP/HTTPS logic is ignored.
      Since:
        5.1.0.1
      See Also:
        Constant Field Values

    - #### ENCODE_LOCALE_INTO_PATH

          public static final String ENCODE_LOCALE_INTO_PATH

      If "true" (the default), then the `PersistentLocale` will be encoded into the `Link` path by the `ComponentEventLinkEncoder` service. If overridden to "false" this does not occur, but you should provide a `LinkCreationListener2` (registered with the `LinkCreationHub`) in order to add the locale as a query parameter (or provide some alternate means of persisting the locale between requests).
      Since:
        5.1.0.1
      See Also:
        Constant Field Values

    - #### COMBINE_SCRIPTS

          public static final String COMBINE_SCRIPTS

      If "true" then JavaScript files in a `JavaScriptStack` will be combined into a single virtual JavaScript file. Defaults to "true" in production mode.
      Since:
        5.1.0.2
      See Also:
        Constant Field Values

    - #### COOKIE_MAX_AGE

          public static final String COOKIE_MAX_AGE

      The default time interval that cookies created by Tapestry will be kept in the client web browser. The default is "7 d" (that is, seven days).
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### START_PAGE_NAME

          public static final String START_PAGE_NAME

      The logical name of the start page, the page that is rendered for the root URL.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### DEFAULT_STYLESHEET

          public static final String DEFAULT_STYLESHEET

      The default stylesheet automatically inserted into every rendered HTML page when no Bootstrap version is enabled (i.e both `Trait.BOOTSTRAP_3` and `Trait.BOOTSTRAP_4` traits are disabled, something done by NoBootstrapModule). It was deprecated in 5.4 with no replacement (the stylesheet is now associated with the core `JavaScriptStack`.), but undeprecated in 5.5.0 with the caveat described above.
      Since:
        5.2.0
      See Also:
        `NoBootstrapModule`, Constant Field Values

    - #### SCRIPTACULOUS

          public static final String SCRIPTACULOUS

      The Asset path to the embedded copy of script.aculo.us packaged with Tapestry.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### DATEPICKER

          public static final String DATEPICKER

      The Asset path to the embedded datepicker.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### COMPACT_JSON

          public static final String COMPACT_JSON

      If "true", then JSON page initialization content is compressed; if "false" then extra white space is added (pretty printing). Defaults to "true" in production mode.
      Since:
        5.2.0
      See Also:
        Constant Field Values

    - #### COMPONENT_RENDER_TRACING_ENABLED

          public static final String COMPONENT_RENDER_TRACING_ENABLED

      If "true" and `PRODUCTION_MODE` is off, comments will be rendered before and after the rendering of any component allowing more visibility into which components rendered which markup. Defaults to "false". Component render tracing may be enabled per-request by the presence of a request parameter "t:component-trace" with a value of "true".
      Since:
        5.2.5
      See Also:
        Constant Field Values

    - #### HOSTNAME

          public static final String HOSTNAME

      The hostname that application should use when constructing an absolute URL. The default is "", i.e. an empty string, in which case system will use request.getServerName(). Not the same as environment variable HOSTNAME, but you can also contribute "$HOSTNAME" as the value to make it the same as the environment variable HOSTNAME.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### HOSTPORT

          public static final String HOSTPORT

      The hostport that application should use when constructing an absolute URL. The default is "0", i.e. use the port value from the request.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### HOSTPORT_SECURE

          public static final String HOSTPORT_SECURE

      The secure (https) hostport that application should use when constructing an absolute URL. The default is "0", i.e. use the value from the request.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### MINIFICATION_ENABLED

          public static final String MINIFICATION_ENABLED

      If "true", then resources (individually or when aggregated into stacks) will be minimized via the `ResourceMinimizer` service. If "false", then minification is disabled. Tracks production mode (minification is normally disabled in development mode). Note that Tapestry's default implementation of `ResourceMinimizer` does nothing; minification is provided by add-on libraries.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### CLUSTERED_SESSIONS

          public static final String CLUSTERED_SESSIONS

      If "true" then at the end of each request the `SessionPersistedObjectAnalyzer` will be called on each session persisted object that was accessed during the request. This is provided as a performance enhancement for servers that do not use clustered sessions. The default is `true`, to preserve 5.2 behavior. For non-clustered applications (the majority), this value should be overridden to `false`. A future release of Tapestry may change the default.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### APPLICATION_FOLDER

          public static final String APPLICATION_FOLDER

      The name of a folder in which the Tapestry application executes. Prior to 5.3, a Tapestry application always responded to all URLs in the context under the context root; by setting this to the name of a folder, the T5 URLs will be inside that folder only, and should match a corresponding entry in the `web.xml` configuration file. This is useful when running multiple servlets within the same web application (such as when migrating from Tapestry 4 or some other framework, to Tapestry 5). Effectively, if this symbol is set to a value, that folder name will be placed after the context path (typically "/") and before the locale, page name, or other prefix. For example, if this symbol is set to "app", the `web.xml <url-pattern>` should be set to `/app/*`, and Tapestry will only be in invoked by the servlet container for requests inside the virtual `app` folder. This also affects the search for page templates (which are allowed within the web context). When set to a non-blank value, page templates are searched for in the folder, rather than in the root context. The default value is the empty string, which preserves Tapestry 5.2 behavior (and continues to be appropriate for most applications). Note that while Tapestry is case-insensitive, the servlet container is not, so the configured value must exactly match the folder name inside the `<url-parameter>` value, including case.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### ASSET_URL_FULL_QUALIFIED

          public static final String ASSET_URL_FULL_QUALIFIED

      Boolean value to indicate if every `Asset2` should be fully qualified or not. Default to `false` meaning no Asset URL will be fully qualified.
      Since:
        5.3
      See Also:
        Constant Field Values

    - #### ASSET_PATH_PREFIX

          public static final String ASSET_PATH_PREFIX

      Prefix to be used for all resource paths, used to recognize which requests are for assets. This value is appended to the context path and the (optional application folder. It may contain slashes, but should not begin or end with one. The default is "assets".
      See Also:
        Constant Field Values

    - #### MODULE_PATH_PREFIX

          public static final String MODULE_PATH_PREFIX

      Prefix used for all module resources. This may contain slashes, but should not being or end with one. Tapestry will create two `Dispatcher`s from this: one for normal modules, the other for GZip compressed modules (by appending ".gz" to this value). The default is "modules".
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### CONTEXT_PATH

          public static final String CONTEXT_PATH

      Identifies the context path of the application, as determined from `ServletContext.getContextPath()`. This is either a blank string or a string that starts with a slash but does not end with one.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### HMAC_PASSPHRASE

          public static final String HMAC_PASSPHRASE

      A passphrase used as the basis of hash-based message authentication (HMAC) for any object stream data stored on the client. The default phrase is the empty string, which will result in a logged runtime error. You should configure this to a reasonable value (longer is better) and ensure that all servers in your cluster share the same value (configuring this in code, rather than the command line, is preferred).
      Since:
        5.3.6
      See Also:
        `ClientDataEncoder`, Constant Field Values

    - #### BOOTSTRAP_ROOT

          public static final String BOOTSTRAP_ROOT

      The root asset path for Twitter Bootstrap; if your application uses a modified version of Bootstrap, you can override this symbol to have Tapestry automatically use your version. The value should be a path to a folder (under "classpath:" or "context:") and should not include a trailing slash.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### FONT_AWESOME_ROOT

          public static final String FONT_AWESOME_ROOT

      The root asset path for Font Awesome; if your application uses a modified version of it, you can override this symbol to have Tapestry automatically use your version. The value should be a path to a folder (under "classpath:" or "context:") and should not include a trailing slash.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### JAVASCRIPT_INFRASTRUCTURE_PROVIDER

          public static final String JAVASCRIPT_INFRASTRUCTURE_PROVIDER

      Tapestry relies on an underlying client-side JavaScript infrastructure framework to handle DOM manipulation, event handling, and Ajax requests. Through Tapestry 5.3, the foundation was Prototype. In 5.4, support for jQuery has been added, and it is possible to add others. This symbol defines a value that is used to select a resource that is provided to the `ModuleManager` service as a `JavaScriptModuleConfiguration` to provide a specific implementation of the `t5/core/dom` module. Tapestry 5.4 directly supports "prototype" or "jquery". To support other foundation frameworks, override this symbol value and supply your own module configuration. In Tapestry 5.4, this defaults to "prototype" for compatibility with 5.3. This will likely change in 5.5 to default to "jquery". At some point in the future, Prototype support will no longer be present.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### SESSION_LOCKING_ENABLED

          public static final String SESSION_LOCKING_ENABLED

      If true (the default), then Tapestry will apply locking semantics around access to the `HttpSession`. Reading attribute names occurs with a shared read lock; getting or setting an attribute upgrades to an exclusive write lock. This can tend to serialize threads when a number of simultaneous (Ajax) requests from the client arrive ... however, many implementations of HttpSession are not thread safe, and often mutable objects are stored in the session and shared between threads. Leaving this on the default will yield a more robust application; setting it to false may speed up processing for more Ajax intensive applications (but care should then be given to ensuring that objects shared inside the session are themselves immutable or thread-safe).
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### INCLUDE_CORE_STACK

          public static final String INCLUDE_CORE_STACK

      If true (the default), then Tapestry will automatically include the "core" stack in all pages.
      Since:
        5.4
      See Also:
        TAP5-2169, Constant Field Values

    - #### FORM_GROUP_WRAPPER_CSS_CLASS

          public static final String FORM_GROUP_WRAPPER_CSS_CLASS

      Defines the CSS class that will be given to HTML element (usually a div) <div> generated by the FormGroup mixin and the BeanEditForm and BeanEditor components surrounding the label and the field. If the value isn't `form-group`, the div will have `class="form-group [value]`. The default value is `form-group`.
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME

          public static final String FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME

      Defines the name of the HTML element that will surround the HTML form field generated by the FormGroup mixin and the BeanEditForm and BeanEditor. If this symbol is null or an empty string, no element will be generated surrouding the form field. The default value is the empty string (no wrapping).
      Since:
        5.4
      See Also:
        TAP5-2182, `FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS`, Constant Field Values

    - #### FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS

          public static final String FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_CSS_CLASS

      Defines the CSS class of the HTML element generated by the FormGroup mixin and the BeanEditForm and BeanEditor. when FORM_GROUP_FORM_FIELD_WRAPPER_ELEMENT_NAME is not set to null or the empty string. The default value is the empty string (no CSS class added).
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### FORM_GROUP_LABEL_CSS_CLASS

          public static final String FORM_GROUP_LABEL_CSS_CLASS

      Defines the CSS class that will be given to <label> element generated by the FormGroup mixin and the BeanEditForm and BeanEditor components. The default value is `control-label`.
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### FORM_FIELD_CSS_CLASS

          public static final String FORM_FIELD_CSS_CLASS

      Defines the CSS class that will be given to form field components which are AbstractField subclasses. The default value is `form-control`.
      Since:
        5.4
      See Also:
        TAP5-2182, Constant Field Values

    - #### BEAN_DISPLAY_CSS_CLASS

          public static final String BEAN_DISPLAY_CSS_CLASS

      Defines the CSS class that will be given to the <dl> HTML element generated by BeanDisplay. The default value is `well dl-horizontal`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### BEAN_EDITOR_BOOLEAN_PROPERTY_DIV_CSS_CLASS

          public static final String BEAN_EDITOR_BOOLEAN_PROPERTY_DIV_CSS_CLASS

      Defines the CSS class that will be given to the <div> HTML element generated by BeanEditor/BeanEditForm for boolean properties. The default value is `input-group`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERROR_CSS_CLASS

          public static final String ERROR_CSS_CLASS

      Defines the CSS class that will be given to the HTML element generated by Error. If the value isn't `help-block`, the class attribute will be `help-block [symbol value]` The default value is `help-block`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### AJAX_FORM_LOOP_ADD_ROW_LINK_CSS_CLASS

          public static final String AJAX_FORM_LOOP_ADD_ROW_LINK_CSS_CLASS

      Defines the CSS class that will be given to the add row link generated by AjaxFormLoop. The default value is `btn btn-default btn-sm`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERRORS_BASE_CSS_CLASS

          public static final String ERRORS_BASE_CSS_CLASS

      Defines the prefix of the CSS class that will be given to the outer <div> element generated by Errors. The value of Errors's `class` parameter appended after the prefix and a space character. The default value is `alert-dismissable`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERRORS_DEFAULT_CLASS_PARAMETER_VALUE

          public static final String ERRORS_DEFAULT_CLASS_PARAMETER_VALUE

      Defines the default value of the Errors's `class` parameter. The default value for this symbol is `alert alert-danger`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### ERRORS_CLOSE_BUTTON_CSS_CLASS

          public static final String ERRORS_CLOSE_BUTTON_CSS_CLASS

      Defines the CSS class that will be given to the close <button> generated by Errors. The default value is `close`.
      Since:
        5.5
      See Also:
        Constant Field Values

    - #### LENIENT_DATE_FORMAT

          public static final String LENIENT_DATE_FORMAT

      Defines whether `DateFormat` instances created by Tapestry should be lenient or not by default. The default value is `false`.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### EXCEPTION_REPORTS_DIR

          public static final String EXCEPTION_REPORTS_DIR

      The directory to which exception report files should be written. The default is appropriate for development: `build/exceptions`, and should be changed for production.
      Since:
        5.4
      See Also:
        `ExceptionReporter`, Constant Field Values

    - #### STRICT_CSS_URL_REWRITING

          public static final String STRICT_CSS_URL_REWRITING

      Defines whether `CSSURLRewriter` will throw an exception when a CSS file references an URL which doesn't exist. The default value is `false`.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### OMIT_EXPIRATION_CACHE_CONTROL_HEADER

          public static final String OMIT_EXPIRATION_CACHE_CONTROL_HEADER

      When an asset (typically, a JavaScript module) is streamed without an explicit expiration header, then this value is sent as the `Cache-Control` header; the default is "max-age=60, must-revalidate". Setting max-age to a value above zero significantly reduces the number of client requests for module content, as client browsers will then cache previously downloaded versions. For normal assets, which are immutable, and fingerprinted with a content hash, there is no need to set max age, and instead, a far-future expiration date is provided.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### ENABLE_HTML5_SUPPORT

          public static final String ENABLE_HTML5_SUPPORT

      Defines whether HTML5 features should be used. Value used in the default implementation of `Html5Support.isHtml5SupportEnabled()`. Default value: `false`.
      Since:
        5.4
      See Also:
        `Html5Support.isHtml5SupportEnabled()`, Constant Field Values

    - #### RESTRICTIVE_ENVIRONMENT

          public static final String RESTRICTIVE_ENVIRONMENT

      A general switch for restrictive environments, such as Google App Engine, which forbid some useful operations, such as creating files or directories. Defaults to false.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### ENABLE_PAGELOADING_MASK

          public static final String ENABLE_PAGELOADING_MASK

      If true, then when a page includes any JavaScript, a `script` block is added to insert a pageloader mask into the page; the pageloader mask ensure that the user can't interact with the page until after the page is fully initialized.
      Since:
        5.4
      See Also:
        Constant Field Values

    - #### PRELOADER_MODE

          public static final String PRELOADER_MODE

      Controls in what environment page preloading should occur. By default, preloading only occurs in production.
      Since:
        5.4
      See Also:
        `PagePreloader`, `PreloaderMode`, Constant Field Values

  - ### Constructor Detail

    - #### SymbolConstants

          public SymbolConstants()

5.6.0 - Copyright © 2003-2020 The Apache Software Foundation.